<?php

namespace swf;

/*
    SWF.php: Macromedia Flash (SWF) file parser
    Copyright (C) 2012 Thanos Efraimidis (4real.gr)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class SWF {
    public $header; // Header
    public $tags; // Tags

    private $io; // SWFio for basic I/O
    private $rec; // SWFrec for simple and complex records
    private $hdr; // SWFhdr for header
    private $tag; // SWFtag for tags

    public function __construct($b) {
        $this->io = new SWFio($b);
        $this->rec = new SWFrec($this->io);
        $this->hdr = new SWFhdr($this->io, $this->rec);
        $this->header = $this->hdr->parseHeader();
        $this->tag = new SWFtag($this->io, $this->rec, $this->header['version']);
        $this->tags = $this->tag->parseTags();
    }

    public function parseTag($tag) {
        return $this->tag->parseTag($tag);
    }
}
