<?php

namespace swf;

/*
    SWF.php: Macromedia Flash (SWF) file parser
    Copyright (C) 2012 Thanos Efraimidis (4real.gr)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


class SWFhdr {
    private $io; // SWFio for basic I/O
    private $rec; // SWFrec for simple and complex records

    public function __construct($io, $rec) {
        $this->io = $io;
        $this->rec = $rec;
    }

    public function parseHeader() {
        $signature = $this->io->collectBytes(3);
        if ($signature == 'CWS') {
            $compressed = true;
        } else if ($signature == 'FWS') {
            $compressed = false;
        } else {
            throw new \Exception(sprintf('Internal error: signature=[%s]', $signature));
        }
        $version = $this->io->collectUI8();
        $fileLength = $this->io->collectUI32();
        if ($compressed) {
            $this->io->doUncompress();
        }
        $frameSize = $this->rec->collectRect();
        $frameRate = $this->io->collectFixed8();
        $frameCount = $this->io->collectUI16();
        return
            array('signature' => $signature,
                'version' => $version,
                'fileLength' => $fileLength,
                'frameSize' => $frameSize,
                'frameRate' => $frameRate,
                'frameCount' => $frameCount);
    }
}