<?php

namespace swf2ass\ass;

use swf2ass\Constants;
use swf2ass\StyleRecord;

class blurEdgesGaussianTag implements ASSStyleTag {

    /** @var int|float */
    private $strength;

    public function __construct($strength = 0) {
        $this->strength = $strength;
    }

    public function transitionStyleRecord(ASSLine $line, StyleRecord $record): ?blurEdgesGaussianTag {
        return self::fromStyleRecord($record);
    }

    public function encode(ASSEventTime $event): string {
        return "\\blur" . round($this->strength, 4);
    }

    public static function fromStyleRecord(StyleRecord $record): ?blurEdgesGaussianTag {
        //TODO?
        return new blurEdgesGaussianTag(0);
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and abs($this->strength - $tag->strength) <= Constants::EPSILON;
    }
}