<?php

namespace swf2ass\ass;

use swf2ass\ClipPath;
use swf2ass\Constants;
use swf2ass\LineRecord;
use swf2ass\Shape;
use swf2ass\Vector2;

abstract class clippingTag extends drawingTag implements ASSClipPathTag {
    protected int $scale;

    protected bool $isNull;
    public function __construct(?ClipPath $clip, $scale = 6) {
        if($clip === null){
            $this->isNull = true;
            $shape = new Shape([]);
        }else{
            $this->isNull = false;
            $shape = $clip->getShape();
            if(count($shape->getRecords()) === 0){ //Full clip
                $shape = new Shape([new LineRecord(new Vector2(0, Constants::TWIP_SIZE), new Vector2(0, 0))]);
            }
        }
        parent::__construct($shape);
        $this->scale = $scale;
    }

    public function transitionClipPath(ASSLine $line, ?ClipPath $clip): ?clippingTag{
        if($clip === null){
            return $this->isNull ? $this : null;
        }

        return $this->shape->equals($clip->getShape()) ? $this : null;
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and $this->isNull === $tag->isNull and $this->shape->equals($tag->shape);
    }
}