<?php

namespace swf2ass\ass;

use swf2ass\Color;
use swf2ass\ColorTransform;
use swf2ass\StyleRecord;

abstract class colorTag implements ASSStyleTag, ASSColorTag {

    protected ?Color $color;
    protected ?Color $originalColor;

    public function __construct(?Color $color, ?Color $originalColor) {
        $this->color = $color;
        $this->originalColor = $originalColor;
    }

    public static abstract function fromStyleRecord(StyleRecord $record): ?colorTag;

    public function transitionStyleRecord(ASSLine $line, StyleRecord $record): ?colorTag {
        return $this::fromStyleRecord($record);
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and ($this->color === $tag->color or ($this->color !== null and $this->color->equals($tag->color))) and ($this->originalColor === $tag->originalColor or ($this->originalColor !== null and $this->originalColor->equals($tag->originalColor)));
    }

    public function applyColorTransform(?ColorTransform $transform): ?colorTag {
        return $transform !== null ? (new $this($this->originalColor !== null ? $transform->applyToColor($this->originalColor) : $this->color, $this->originalColor)) : $this;
    }

    public function transitionColor(ASSLine $line, ColorTransform $transform): ?colorTag {
        return $this->applyColorTransform($transform);
    }
}