<?php

namespace swf2ass\ass;

use swf2ass\Constants;
use swf2ass\MoveRecord;
use swf2ass\Shape;

class drawTag extends drawingTag implements ASSPathTag {

    protected int $scale;
    public function __construct(Shape $shape, $scale = 6) {
        parent::__construct($shape);
        $this->scale = $scale;
    }

    public function transitionShape(ASSLine $line, Shape $shape): ?drawTag{
        return $this->shape->equals($shape) ? $this : null;
    }

    public function encode(ASSEventTime $event): string {
        $scaleMultiplier = 2 ** ($this->scale - 1);
        return "\\p".$this->scale."}" . implode(" ", $this->getCommands($scaleMultiplier, $this->scale >= 5 ? 0 : 2)) . "{\\p0";
    }
}