<?php

namespace swf2ass\ass;

use swf2ass\Constants;
use swf2ass\MatrixTransform;
use swf2ass\StyleRecord;
use swf2ass\Vector2;

class originTag implements ASSTag {

    private Vector2 $origin;

    public function __construct(Vector2 $origin) {
        $this->origin = $origin;
    }

    public function encode(ASSEventTime $event): string {
        return "\\org(" . round($this->origin->x, 5) ."," . round($this->origin->y, 5) .")";
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and $this->origin->equals($tag->origin);
    }
}