<?php

namespace swf2ass\ass;

use swf2ass\Constants;
use swf2ass\MatrixTransform;
use swf2ass\StyleRecord;
use swf2ass\Vector2;

class scaleTag implements ASSPositioningTag {

    private Vector2 $scale;

    public function __construct(Vector2 $scale) {
        $this->scale = $scale;
    }

    public function transitionMatrixTransform(ASSLine $line, MatrixTransform $transform): ?scaleTag {
        return self::fromMatrixTransform($transform);
    }

    public function encode(ASSEventTime $event): string {
        return sprintf("\\fscx%.5F\\fscy%.5F", $this->scale->x, $this->scale->y);
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and $this->scale->equals($tag->scale);
    }

    public static function fromMatrixTransform(MatrixTransform $transform): ?scaleTag {
        return new scaleTag($transform->decomposeQR()->scale->abs()->multiply(100));
    }
}