<?php

namespace swf2ass\ass;

use swf2ass\Constants;
use swf2ass\MatrixTransform;
use swf2ass\StyleRecord;
use swf2ass\Vector2;

class shearingTag implements ASSPositioningTag {

    private Vector2 $shear;

    public function __construct(Vector2 $shear) {
        $this->shear = $shear;
    }

    public function transitionMatrixTransform(ASSLine $line, MatrixTransform $transform): ?shearingTag {
        return self::fromMatrixTransform($transform);
    }

    public function encode(ASSEventTime $event): string {
        return sprintf("\\fax%.5F\\fay%.5F", $this->shear->x, $this->shear->y);
    }

    public function equals(ASSTag $tag): bool {
        return $tag instanceof $this and $this->shear->equals($tag->shear);
    }

    public static function fromMatrixTransform(MatrixTransform $transform): ?shearingTag {
        return new shearingTag(new Vector2($transform->get_b(), $transform->get_c()));
    }
}